Subject: bug#61205: 'function' in 3rd element of treesit-font-lock-feature-list

From: Dmitry Gutov <[email-masked]>
Date: Thu, 2 Feb 2023 04:44:28 +0200

On 02/02/2023 04:34, Randy Taylor wrote:
> On Tuesday, January 31st, 2023 at 21:08, Dmitry Gutov<[email-masked]>  wrote:
>> X-Debbugs-Cc: Yuan [email-masked], Randy [email-masked]
>>
>>
>> Some new built-in modes has 'function' feature highlighting thus enabled
>> by default.
>>
>> rust-ts-mode, go-ts-mode, cmake-mode
>>
>> Should we move it to 4 for consistency with the rest?
>>
>> Previously, we talked about that and concluded that function calls are
>> usually everywhere and are easy to notice without additional highlighting.
> If that's what folks decided on then we should keep everything consistent.
> 
> Personally, I find it odd that out of the box default highlighting wouldn't highlight function calls.

I think that's more useful in some languages, and less in others.

I guess we settled on this particular convention to be more consistent 
with existing major modes in Emacs. But I can see how it can be 
appealing, especially in languages with more complex syntax such as Rust.

Same for 'property'.

The one feature that I'm fairly certain is currently useless is 
'variable', because we don't have any variable scope tracking (yet), and 
the grammars don't do it for us. So too many tokens get highlighted with 
font-lock-variable-name-face. Try the current rust-ts-mode, for example: 
almost everything ends up with that face.